unit Config;

interface
 uses Windows,SysUtils,SelfSave;

const
 sfCfg     : array [1..2] of string =('cfg1.bin','cfg2.bin');
 sfCmd     : array [1..2] of string =('cmd1.txt','cmd2.txt');
 sfLog     : array [1..2] of string =('log1.txt','log2.txt');

type TCfg = class (TSelfSave)
 public
  sComm    :String;
  AutoOpen :DWORD;
  Redirect :DWORD;
  SaveCmd  :DWORD;
  CommCfg  :_COMMCONFIG;
  HexOut   :DWORD;
  AddLn    :DWORD;
  wpInit   :DWORD;
  wpOnl2   :DWORD;
  wpWnd1   :DWORD;
  wpWnd2   :DWORD;
  wpTopa   :DWORD;
  wpLeft   :DWORD;
  wpHigh   :DWORD;
  wpLong   :DWORD;
  wpCmd1   :DWORD;
  wpCmd2   :DWORD;

 constructor Create(FileName:string);
 procedure   Free;
 class procedure Init;
 class var pOffsets: PInteger;
end;

var
 Cfg1,Cfg2  :TCfg;

implementation

{ TCfg }

constructor TCfg.Create(FileName: string);
begin
 if pOffsets=nil then Init;
 fOffsets:=pOffsets;
 SelfLoad(FileName);
end;

procedure TCfg.Free;
begin
 SelfSave;
 inherited;
end;

class procedure TCfg.Init;
var
 C:TCfg;
 p:Pointer;
const
 cCfgMaxParm=32;
 _d=sizeof(C.CommCfg);
begin
 GetMem(pOffsets,cCfgMaxParm*8);
 p:=pOffsets;
 asm
  mov edi,0;
  mov eax,p
  mov [eax+edi],offset(TCfg.sComm);          mov [eax+edi+4],-1;  add edi,8;
  mov [eax+edi],offset(TCfg.AutoOpen);       mov [eax+edi+4], 4;  add edi,8;
  mov [eax+edi],offset(TCfg.SaveCmd);        mov [eax+edi+4], 4;  add edi,8;
  mov [eax+edi],offset(TCfg.Redirect);       mov [eax+edi+4], 4;  add edi,8;
  mov [eax+edi],offset(TCfg.CommCfg);        mov [eax+edi+4],_d;  add edi,8;
  mov [eax+edi],offset(TCfg.HexOut);         mov [eax+edi+4], 4;  add edi,8;
  mov [eax+edi],offset(TCfg.AddLn);          mov [eax+edi+4], 4;  add edi,8;

  mov [eax+edi],offset(TCfg.wpInit);         mov [eax+edi+4], 4;  add edi,8;
  mov [eax+edi],offset(TCfg.wpOnl2);         mov [eax+edi+4], 4;  add edi,8;
  mov [eax+edi],offset(TCfg.wpWnd1);         mov [eax+edi+4], 4;  add edi,8;
  mov [eax+edi],offset(TCfg.wpWnd2);         mov [eax+edi+4], 4;  add edi,8;
  mov [eax+edi],offset(TCfg.wpTopa);         mov [eax+edi+4], 4;  add edi,8;
  mov [eax+edi],offset(TCfg.wpLeft);         mov [eax+edi+4], 4;  add edi,8;
  mov [eax+edi],offset(TCfg.wpHigh);         mov [eax+edi+4], 4;  add edi,8;
  mov [eax+edi],offset(TCfg.wpLong);         mov [eax+edi+4], 4;  add edi,8;
  mov [eax+edi],offset(TCfg.wpCmd1);         mov [eax+edi+4], 4;  add edi,8;
  mov [eax+edi],offset(TCfg.wpCmd2);         mov [eax+edi+4], 4;  add edi,8;
  mov [eax+edi],0;                           mov [eax+edi+4], 0;  add edi,8;
  mov [eax+edi],0;                           mov [eax+edi+4], 0;  add edi,8;
 end;
end;

end.



